include:
  - template: Code-Quality.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml


variables:
  DOCKER_HOST: "tcp://docker:2375"
  DOCKER_TLS_CERTFIR: "/certs"
  CONTAINER_DEVELOP_LATEST_TAG: $CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_LATEST_TAG: latest

stages:
  - build
  - test

code_quality:
  artifacts:
    paths: 
      - gl-code-quality-report.json

dependency_scanning:
  artifacts:
    paths:
      - gl-dependency-scanning-report.json

license_scanning:
  artifacts:
    paths:
      - gl-license-scanning-report.json
    reports:
      license_scanning: gl-license-scanning-report.json


build-develop:
  stage: build
  image: docker:latest
  services:
    - docker:19.03.5-dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --pull -t "$CI_REGISTRY_IMAGE:$CONTAINER_DEVELOP_LATEST_TAG" -f docker/Dockerfile .
    - docker push "$CI_REGISTRY_IMAGE"
  rules:
    - if: $CI_COMMIT_BRANCH == "develop"


build-tags:
  stage: build
  image: docker:latest
  services:
    - docker:19.03.5-dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --pull -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG" -f docker/Dockerfile .
    - docker tag "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG" "$CI_REGISTRY_IMAGE:$CONTAINER_RELEASE_LATEST_TAG"
    - docker push "$CI_REGISTRY_IMAGE"
  rules:
    - if: $CI_COMMIT_TAG

test:
  stage: test
  image: docker:latest
  services:
    - docker:19.03.5-dind
  script: 
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull "$CI_REGISTRY_IMAGE:$CONTAINER_RELEASE_LATEST_TAG"
    - docker inspect "$CI_REGISTRY_IMAGE:$CONTAINER_RELEASE_LATEST_TAG" 